#include <iostream>

using namespace std;

void printALine(int n, char symbol, int i);

void printTriangle(int n);

void printOppositeTriangles(int n);

void printRuler(int n);

int main() {
    cout << "Print a triangle:\n";
    printTriangle(4);

    cout << "Print opposite triangles:\n";
    printOppositeTriangles(4);

    cout << "print a ruler:\n";
    printRuler(4);
    return 0;
}

void printALine(int n, char symbol, int i = 1) {
    if (i == n) {
        cout << symbol << endl;
        return;
    }
    cout << symbol;
    printALine(n, symbol, ++i);
}

void printTriangle(int n) {
    printALine(n, '*');
    if (n == 1) return;
    printTriangle(n - 1);
}

void printOppositeTriangles(int n) {
    printALine(n, '*');
    if (n == 1) return;
    printOppositeTriangles(n - 1);
    printALine(n, '*');
}

void printRuler(int n) {
    if (n==0) return;
    printRuler(n - 1);
    printALine(n, '-');
    printRuler(n - 1);
}



