#include <iostream>

using namespace std;

int minInArray1(int arr[], int arrSize);

int minInArray2(int arr[], int low, int high);

int main() {
    int arr[10] = {9, -2, 14, 12, 3, 6, 2, 1, -9, 15};
    int res1, res2, res3, res4;
    res1 = minInArray1(arr, 10);
    res2 = minInArray2(arr, 0, 9);

    cout << res1 << " " << res2 << endl; //should both be -9
    res3 = minInArray2(arr, 2, 5);
    res4 = minInArray1(arr + 2, 4); //arr+2 is equivalent to &(arr[2])
    cout << res3 << " " << res4 << endl; //should both be 3

    return 0;
}

int smallerNum(int a, int b) {
    if (a < b) return a;
    return b;
}

int minInArray1(int arr[], int arrSize) {
    // base case
    if (arrSize == 1) return arr[0];
    else if (arrSize == 2) return smallerNum(arr[0], arr[1]);

    int mid = arrSize / 2;
    return smallerNum(minInArray1(arr, mid), minInArray1(arr + mid, arrSize - mid));
}

int minInArray2(int arr[], int low, int high) {
    if (low + 1 >= high) return smallerNum(arr[low], arr[high]);
    int mid = (high + low) / 2;
    return smallerNum(minInArray2(arr, low, mid), minInArray2(arr, mid + 1, high));
}